var getPresetCount = function () {
    var count = 0;

    try {
        var lw3Connection = new TcpConnection(deviceIp, 6107, 1000, 1000, 5);

        var presetCountGetProperty = new GetProperty(lw3Connection, new Property("Count", new Path("/PRESETS/DEVICE")));
        presetCountGetProperty.execute();

        count = parseInt(presetCountGetProperty.getProperty().getCachedValue());

    } catch (exception) {
        logger.debug("There is no device preset");
    }

    return count;
};

var getPresetProperties = function (presetId) {
    var lw3Connection = new TcpConnection(deviceIp, 6107, 1000, 1000, 5);

    var getPresetNameProperty = new GetProperty(lw3Connection, new Property("name", new Path("/PRESETS/DEVICE/" + presetId)));
    getPresetNameProperty.execute();
    var presetNameProperty = getPresetNameProperty.getProperty().getCachedValue();

    var presetFileLengthGetProperty = new GetProperty(lw3Connection, new Property("fileLen", new Path("/PRESETS/DEVICE/" + presetId)));
    presetFileLengthGetProperty.execute();
    var fileLength = parseInt(presetFileLengthGetProperty.getProperty().getCachedValue());

    var presetErrorCountGetProperty = new GetProperty(lw3Connection, new Property("errorNum", new Path("/PRESETS/DEVICE/" + presetId)));
    presetErrorCountGetProperty.execute();
    var errorCount = parseInt(presetErrorCountGetProperty.getProperty().getCachedValue());

    var presetWriteProtectedGetProperty = new GetProperty(lw3Connection, new Property("writeProtected", new Path("/PRESETS/DEVICE/" + presetId)));
    presetWriteProtectedGetProperty.execute();
    var writeProtected = presetWriteProtectedGetProperty.getProperty().getCachedValue();

    return {
        'name': presetNameProperty,
        'empty': (0 === fileLength),
        'convertable': ((0 < fileLength) && (0 === errorCount)),
        'writeProtected': ((0 < fileLength) && (writeProtected.toLowerCase() === "true"))
    };
};