include("common_scripts_lib/backup_and_restore/device_configuration_restore.js");
include("common_scripts_lib/backup_and_restore/preset_restore.js");
include("common_scripts_lib/backup_and_restore/miniweb_upload.js");
include("common_scripts_lib/progress/progressUtils.js");
include("common_scripts_lib/legacy/control.js");
include("common_scripts_lib/lw3/control_lw3.js");
include("common_scripts_lib/cleartext_login/cleartextLogin.js");


function restoreFullConfiguration(deviceIp, factoryDefault, partNumber, restoreFromBackup, skipPresetsAtRestore, backupFilePath, presetFilesMetaDataList, indexFileMetaData, applyNetworkSettings, loginEnabled, parentCheckpoint, weightRestoreSettings, weightRestorePresets, weightRestoreMiniWeb) {
    /* Restore settings */
    if (!factoryDefault && restoreFromBackup) {
        var lw3Connection = new TcpConnection(deviceIp, 6107, 5000, 5000, 3);

        /* MMX6X2-590 */
        if (["91310032", "91310031", "91310030"].indexOf(partNumber) >= 0) {
            resetDevice(deviceIp, true, new Method("reset", new Path("/SYS")), 2000, 30000, parentCheckpoint, 0);
        }
        if (typeof skipPresetsAtRestore !== 'undefined' && !skipPresetsAtRestore) {
            restorePresets(presetFilesMetaDataList, 10000, parentCheckpoint, weightRestorePresets);
        } else {
            dummyCheckpointIncrease(parentCheckpoint, weightRestorePresets);
        }

        if (typeof indexFileMetaData !== 'undefined' && indexFileMetaData !== null) {
            restoreCustomMiniWeb(indexFileMetaData, 60000, parentCheckpoint, weightRestoreMiniWeb);
        } else if (typeof uploadDefaultMiniWeb !== 'undefined' && uploadDefaultMiniWeb) {
            uploadPackageSpecificMiniWeb("index-min.html", 60000, parentCheckpoint, weightRestoreMiniWeb);
        } else {
            dummyCheckpointIncrease(parentCheckpoint, weightRestoreMiniWeb);
        }

        restoreSettings(lw3Connection, backupFilePath, applyNetworkSettings, parentCheckpoint, weightRestoreSettings);

        if(loginEnabled) {
            setLoginEnable();
        }

    } else {
        dummyCheckpointIncrease(parentCheckpoint, weightRestoreSettings + weightRestorePresets + weightRestoreMiniWeb);
    }
}
