var logger = LoggerFactory.getLogger("MMX4x2 pre.js");

Object.defineProperty(this, 'SCRIPT_API_MIN_VERSION', {value: '1.3.6'});
Object.defineProperty(this, 'LDU_MIN_VERSION', {value: '2.5.0'});

addSupportedPartNumbers(
    /* MMX4x2-HDMI  */              91310034,
    /* MMX4x2-HT200 */              91310035,
    /* MMX4x2-HDMI-USB20-L */       91310076,
    /* MMX4x2-HDMI-USB20-Slim */    91310077,
    /* HDMI-TPS-RX200_VER_ENG */    91540039
);

mapCpuFileNameToPartNumbers("tps_rx200.bin", 91310034, 91310035, 91540039, 91310076, 91310077);

var params = new Array();

var validateParams = function() {

    /* factoryDefault*/
    params.push("factoryDefault");
    if(typeof factoryDefault === 'undefined'){
        factoryDefault = false;

    } else if(typeof factoryDefault === "string") {
        if(factoryDefault != "true" && factoryDefault!= "false") {
            return false;
        }
        if(factoryDefault === "true") {
           factoryDefault = true;
        } else{
           factoryDefault = false;
        }
    }

    /* forceNoBackup*/
    params.push("forceNoBackup");
    if(typeof forceNoBackup === 'undefined'){
        forceNoBackup = false;

    } else if(typeof forceNoBackup === "string") {
        if(forceNoBackup != "true" && forceNoBackup!= "false") {
            return false;
        }
        if(forceNoBackup === "true") {
           forceNoBackup = true;
        } else{
           forceNoBackup= false;
        }
    }

    /* restoreFromBackup */
    params.push("restoreFromBackup");
    if(typeof restoreFromBackup === 'undefined') {
        if(forceNoBackup === false && factoryDefault === false) {
            restoreFromBackup = true;
        } else {
            restoreFromBackup = false;
        }
    } else if (typeof restoreFromBackup === "string") {
        if(restoreFromBackup != "true" && restoreFromBackup != "false") {
            return false;
        }
        if(restoreFromBackup === "true") {
           restoreFromBackup = true;
        } else{
           restoreFromBackup = false;
        }
    }

    if(forceNoBackup === true && restoreFromBackup === true) {
        return false;
    }

    if(factoryDefault === true && restoreFromBackup === true) {
        return false;
    }

    /* skipPresetsAtRestore */
     params.push("skipPresetsAtRestore");
     if(typeof skipPresetsAtRestore === "string") {
         if(skipPresetsAtRestore != "true" && skipPresetsAtRestore!= "false") {
             return false;
         }
         if(skipPresetsAtRestore === "true") {
            skipPresetsAtRestore = true;
         } else{
            skipPresetsAtRestore = false;
         }
     }
     else {
         skipPresetsAtRestore = false;
     }

    /* updateVs100 */
    params.push("updateVs100");
    if(typeof updateVs100 === 'undefined'){
        updateVs100 = false;

    } else if(typeof updateVs100 === "string") {
        if(updateVs100 != "true" && updateVs100!= "false") {
            return false;
        }
        if(updateVs100 === "true") {
           updateVs100 = true;
        } else{
           updateVs100= false;
        }
    }
    
    /* uploadDefaultMiniWeb */
    params.push("uploadDefaultMiniWeb");
    if(typeof uploadDefaultMiniWeb === 'undefined') {
        uploadDefaultMiniWeb = false;

    } else if(typeof uploadDefaultMiniWeb === "string") {
        if(uploadDefaultMiniWeb != "true" && uploadDefaultMiniWeb!= "false") {
            return false;
        }
        if(uploadDefaultMiniWeb === "true") {
           uploadDefaultMiniWeb = true;
        } else{
           uploadDefaultMiniWeb= false;
        }
    }

    /* clearTextLoginPw */
    params.push("clearTextLoginPw");
    if(typeof clearTextLoginPw === 'undefined'){
        clearTextLoginPw = "";

    }

    return allParamsDefined(params);
}

var allParamsDefined = function(params) {
    for(var i = 0; i < params.length; i++) {
        if(typeof this[params[i]]=="undefined") {
            return false;
        }
    }
    return true;
}

var printParams = function() {
    print("Backup and restore options:\n");
    print("\tfactoryDefault:\t if set to true device will reset to factory default settings after the upgrade process is finished, default: false");
    print("\trestoreFromBackup:\t if true, no device configuration is restored from the backup created at the begininning of upgrade process (default: true)");
    print("\tskipPresetsAtRestore:\t If true. Device presets will be skipped at restore. (default: false)");
    print("\tbackupFolder:\t folder to create configuration backup into");

    print("\nAdvanced backup and restore options:\n");
    print("\tforceNoBackup:\t if true, no backup file will be created (default: false)");
    print("\tuploadDefaultMiniWeb:\t If true, and no custom miniweb is present on the device, the default miniweb file will be uploaded. (default: false)");

    print("\nLogin options:\n");
    print("\tclearTextLoginPw:\t The login password used when updating devices. (It's cleartext password!)");

    print("\nAdvanced (developer) options:\n");   
    print("\tupdateVs100: If true, the VS100 Rx firmware will also be updated. (default: false)");
}
